Message - Id: $GW3TMH000264
Msg Type: B$
Date: 31 Jan 97 7:22:07
From: GW3TMH
To: LINUX @ WWW
Subject: A Simple Linux Mailbox (49)

R:970131/0722z @:GB7ABC.#51.GBR.EU

forward.c part 1 of 4

/*
 * Linux version.
 *
 * File location...   /ax25/mbx/exec_files/.FORWARD
 *
 */

/******************************************************************************/
/*                                                                            */
/*                                  forward.c                                 */
/*                                                                            */
/* This is the bit that does mail forwarding, it is not complete, and needs   */
/* completeing, one problem at present, is that if a message is entered on    */
/* the mailbox, then deleted, this program hangs.                             */
/*                                                                            */
/* Reverse forwarding is not yet written, I suppose calling the mail_in shell */
/* from this code would do the trick, but not got around to it.               */
/*                                                                            */
/* Time to forward, and message size, have not yet been written, so as a      */
/* temporrary fix, I call this program every hour using crontab, it is also   */
/* called whenever a message is entered.                                      */
/*                                                                            */
/* ***THIS CODE IS NOT STAND ALONE***  it needs linking with the following    */
/* which are included with the ax25 utils by Alan Cox...                      */
/*                                                                            */
/*            convert.c             dostime.c             config.c            */
/*                                                                            */
/******************************************************************************/


#include <sys/types.h>
#include <stdio.h>
#include <ctype.h>
#include <dirent.h>
#include <errno.h>
#include <fcntl.h>
#include <pwd.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <termios.h>
#include <unistd.h>
#include <linux/ax25.h>
#include "config.h"
#include "call.h"

static int backoff = -1;
static int ax25mode = -1;
static int debug_setting = FALSE;
static int netrom_setting = FALSE;
static int window_setting = 0;
static int port_setting = 0;

int interrupted = FALSE;
int paclen = 120;
int fd;

int my_dcd;
int line_number;
char callsign[20];

void cmd_call(char *);
static int connect_to(char *);
int anything_for(char *);
int try_to_connect(char *);
int check_day(char *);
int check_time(char *);
int check_size(char *);
int do_connect(char *);
int get_prompt(void);
void send_sid(void);
void send_msg(int);
void end_prog(void);

int main(int argc, char **argv)
{
int p;
int msg_number;
int polling_flag;
int data_carrier_detect;
char filename[81];

if (access ("/ax25/mbx/tmp/forward.lock", 0) == 0) exit(0);

signal(SIGHUP, SIG_IGN);

if ((p = fork()) < 0) exit(1);
else if (p > 0) exit(0);

p = open("/ax25/mbx/tmp/forward.lock", O_CREAT | O_RDWR, S_IREAD | S_IWRITE);
close(p);

my_dcd = FALSE;

while ((p = getopt(argc, argv, "b:dm:np:w:")) != -1)
   {
   switch(p)
      {
      case 'b':
                if (*optarg != 'e' && *optarg != '1')
                   {
                   fprintf(stderr, "forward: invalid argument for option '-b'\n");
                   end_prog();
                   }

                backoff = *optarg == 'e';
                break;

      case 'd':
                debug_setting = TRUE;
                break;

      case 'm':
                if (*optarg != 's' && *optarg != 'e')
                   {
                   fprintf(stderr, "forward: invalid arguement for option '-m'\n");
                   end_prog();
                   }
          
                ax25mode = *optarg == 'e';
                break;

      case 'n':
                netrom_setting = TRUE;
                break;

      case 'p':
                if ((port_setting = atoi(optarg)) == 0)
                   {
                   fprintf(stderr, "forward: option '-p' requires numeric argument\n");
                   end_prog();
                   }

                port_setting--;
                break;

      case 'w':
                if ((window_setting = atoi(optarg)) == 0)
                   {
                   fprintf(stderr, "forward: option '-w' requires numeric argument\n");
                   end_prog();
                   }

                if (ax25mode)
                   {
                   if (window_setting < 1 || window_setting > 63)
                      {
                      fprintf(stderr, "forward: window must be between 1 and 63 frames\n");
                      end_prog();
                      }
                   }

                else
                   {
                   if (window_setting < 1 || window_setting > 7)
                      {


from: gw3tmh at gb7abc.#51.gbr.eu (The Unix Mailbox)

