Message - Id: $GW3TMH000118
Msg Type: B$
Date: 28 Dec 96 9:48:34
From: GW3TMH
To: LINUX @ WWW
Subject: A Simple Linux Mailbox (14)

R:961228/0948z @:GB7ABC.#51.GBR.EU

/*
 * Linux version.
 *
 * File location... /ax25/mbx/exec_files/l
 *
 */

/******************************************************************************/
/*                                                                            */
/*                                     l.c                                    */
/*                                                                            */
/*                        This is used to list messages                       */
/*                                                                            */
/*           enter the command as...  L   or   L 5   or   L 5 25              */
/*                                                                            */
/******************************************************************************/

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <signal.h>

void sig_ser(int);
void error(int);
void page(void);

int pg;
int ln;
int mn;

/*----------------------------------------------------------------------------*/

void
sig_ser(int i)
{
lockf(mn,F_ULOCK,0);
close(mn);
exit(0);
}

/*----------------------------------------------------------------------------*/

void main(int argc, char *argv[])
{
char Temp[12];
char buffer[81];
int mn1 = 0;
int mn2 = 0;
long L;
FILE *fp;

pg = 0;
ln = 0;

if (argc == 2)
   {
   /* Only one number entered, get the other from the database */
   if (strlen(argv[1]) < 5) mn1 = atoi(argv[1]);
   if (!mn1) error(1);
   }

if (argc == 3)
   {
   /* Two numbers entered, so get them */
   if (strlen(argv[1]) < 5) mn1 = atoi(argv[1]);
   if (strlen(argv[2]) < 5) mn2 = atoi(argv[2]);
   if (!mn1) error(1);
   if (!mn2) error(1);
   }

if (argc > 3) error(1);

sprintf(buffer,"/ax25/mbx/system_files/%s.data",argv[0]);

if ((fp = fopen(buffer,"r")) != NULL)
   {
   fseek(fp,117,SEEK_SET);
   fscanf(fp,"%s %s",buffer,Temp);
   Temp[0] = Temp[4];
   Temp[1] = Temp[5];
   Temp[2] = 0;
   pg = atoi(Temp);
   }

if (mn1 == 0)
   {
   /* mn1 = last listed */
   fseek(fp,65,SEEK_SET);
   fscanf(fp,"%s %s",buffer,Temp);
   mn1 = atoi(Temp);
   }

fclose(fp);

if (mn2 == 0)
   {
   /* mn2 = last.msg */
   mn = open("/ax25/mbx/system_files/last.msg",O_RDONLY);
   lockf(mn,F_LOCK,0);
   signal(SIGHUP,sig_ser);
   read(mn,Temp,9);
   lockf(mn,F_ULOCK,0);
   signal(SIGHUP,SIG_DFL);
   close(mn);
   mn2 = atoi(Temp);
   }

if (mn1 == mn2) error(2);

if ((fp = fopen("/ax25/mbx/system_files/header","r")) != NULL)
   {
   fputs(" Msg#  TS  Size   To    From   @BBS  Date/Time I---------",stdout);
   fputs(" Subject. ---------I\n",stdout);

   if (pg) page();

   L = mn1;
   L--;
   L *= 78;

   fseek(fp,L,SEEK_SET);

   while(mn1 != mn2)
      {
      fgets(buffer,80,fp);
      fputs(buffer,stdout);
      if (pg) page();
      mn1++;
      if (mn1 > 9999)
         {
         mn1 = 1;
         rewind(fp);
         }
      }
   fgets(buffer,80,fp);
   fputs(buffer,stdout);
   if (pg) page();
   fclose(fp);

   /* Now update our personal database */

   sprintf(buffer,"/ax25/mbx/system_files/%s.data",argv[0]);

   if ((fp = fopen(buffer,"r+")) != NULL)
      {
      fseek(fp,65,SEEK_SET);
      fprintf(fp,"List: %06d\n",mn2);
      fclose(fp);
      }
   }
}

/*---------------------------------------------------------------------------*/

void error(a)
int a;
{
if (a == 1) fputs("Bad number.\n",stdout);
else fputs("None found.\n",stdout);
exit(0);
}

/*----------------------------------------------------------------------------*/

void page(void)
{
char temp[81];
int i;

ln++;
if (ln == pg)
   {
   ln = 0;
   fputs("\nMore (A) > ",stdout);
   for (i = 0; i < 80; i++)
      {
      temp[i] = getchar();
      if (temp[i] == '\n') break;
      }
   temp[i] = 0;
   if (!strcmp(temp,"a")) exit(0);
   }
}

/*----------------------------------------------------------------------------*/


from: gw3tmh at gb7abc.#51.gbr.eu (The Unix Mailbox)

