Message - Id: $GW3TMH000206
Msg Type: B$
Date: 20 Jan 97 8:58:34
From: GW3TMH
To: LINUX @ WWW
Subject: A Simple Linux Mailbox (38)

R:970120/0858z @:GB7ABC.#51.GBR.EU

/*
 * Linux version.
 *
 * File location... /ax25/mbx/exec_files/mpf
 *
 */

/*****************************************************************************/
/*                                                                           */
/*                                   mpf.c                                   */
/*                                                                           */
/*                   MPF Make Personal Message from a file.                  */
/*                                                                           */
/*****************************************************************************/

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <signal.h>
#include <ctype.h>

void sig_ser(int);
void error(int);
void parent(void);
void child(char *,char *, char *, char *, char *, char *, char *);

FILE *fp1, *fp2;
char filename[81];

/*----------------------------------------------------------------------------*/

/*
 * Wait until child process has terminated, then remove temp mail file
 */

void
sig_ser(int i)
{
fclose(fp1);
unlink(filename);
exit(0);
}

/*----------------------------------------------------------------------------*/

void main(int argc, char *argv[])
{
int i;
long L;
char hostname[31];
char str[81];
char buf[81];
char to[7];
char from[7];
char at[71];
char type[3];
char mid[14];
char Sent[9];
char tempname[15];

/*     argv[0] = callsign */
/*     argv[1] = to       */
/*     argv[2] = "@"      */
/*     argv[3] = at       */

/*
 * Get the originators callsign.
 */
if (strlen(argv[0]) < 3) error(3);
if (strlen(argv[0]) > 6) error(3);

strcpy(from,argv[0]);

/*
 * Now see if sender is allowed to actually input mail.
 */
if (isalpha(from[0]) && isalpha(from[1]) && isdigit(from[2])) goto good_call;
if (isalpha(from[0]) && isdigit(from[1]) && isalpha(from[2])) goto good_call;
if (isdigit(from[0]) && isalpha(from[1]) && isdigit(from[2])) goto good_call;

error(3);

good_call:

if (argc >  4) error(2);              /* Too many arguments entered    */

if (strlen(argv[1]) > 6) error(3);    /* To callsign too long          */

if (argc == 1) error(4);              /* Nothing entered so send Usage */
if (argc == 3) error(4);              /* Destination entered wrong     */
if (argc > 3 && strcmp(argv[2], "@")) error(4);

if (argc > 3)
   {
   /* We have a destination, check it for length */
   if (strlen(argv[3]) > 70) error(3);
   strcpy(at,argv[3]);
   }
else at[0] = 0;

strcpy(to,argv[1]);
strcpy(type,"P$");

/* Create a mid */
sprintf(filename,"/ax25/mbx/system_files/%s.data",from);

if ((fp1 = fopen(filename,"r+")) != NULL)
   {
   /* If the user has an account, create a mid based on the number */
   /* of messages sent, we thus have an easy way of seeing how many */
   /* messages each user sends */
   fseek(fp1,26,SEEK_SET);
   fscanf(fp1,"%s %s",tempname,Sent);
   L = atol(Sent);
   L++;
   if (L > 999999) L = 0;
   fseek(fp1,26,SEEK_SET);
   fprintf(fp1,"Sent: %06ld\n",L);
   fclose(fp1);
   sprintf(mid,"$%s%06ld",from,L);
   }

else
   {
   /* No user account */
   printf("Unregistered user.\n");
   exit(0);
   }


/* If we get this far we are ready for a message */

printf("Subject: ");

for (i = 0; i < 80; i++)
   {
   str[i] = getchar();
   if (str[i] == '\n') break;
   }
str[i] = 0;

if ((fp1 = fopen("/etc/AX25_HOSTNAME","r")) != NULL)
   {
   fgets(hostname,30,fp1);
   fclose(fp1);

   for (i = 0; i <= 30; i++)
      {
      if (hostname[i] == '\n') break;
      }
   hostname[i] = 0;
   }

/* now create a filename in tmp */
strcpy(tempname,"rmXXXXXX");
mktemp(tempname);

sprintf(filename,"/ax25/mbx/tmp/%s",tempname);

if ((fp1 = fopen(filename,"w")) != NULL)
   {
   signal(SIGHUP,sig_ser);
   if (at[0] == 0) strcpy(at,"------");
   printf("Filename: ");

   fprintf(fp1,"\n");

   for (i = 0; i <= 80; i++)
      {
      buf[i] = getchar();
      if (buf[i] == '\n') break;
      }
   buf[i] = 0;

   if ((fp2 = fopen(buf,"r")) == NULL)
      {
      printf("No such input file (%s)\n",buf);
      fclose(fp1);
      unlink(filename);
      exit(0);
      }

   while(fgets(buf,80,fp2) != NULL)
      {
      fputs(buf,fp1);
      }
   fclose(fp2);
   fputc('\n',fp1);

   /* Now add a signature */

   fprintf(fp1,"\nfrom: %s at %s (The Unix Mailbox)\n",
   from,hostname);

   fclose(fp1);
   signal(SIGHUP,SIG_DFL);

   /* Now pass mail to pmail */

   if (fork()) parent();
   else child(filename,type,to,at,from,mid,str);
   exit(0);
   }
}

/*----------------------------------------------------------------------------*/

/* Process error messages */

void error(e)
int e;
{
switch(e)
   {
   case 1:  printf("No - invalid command.\n");     break;
   case 2:  printf("No - invalid destination.\n"); break;
   case 3:  printf("No - invalid originator.\n");  break; 
   case 4:  printf("Usage: MPF CALL @ CALL\n");     break;
   }
exit(0);
}

/*----------------------------------------------------------------------------*/

void parent(void)
{
exit(0);
}

/*---------------------------------------------------------------------------*/

void child(filename,type,to,at,from,mid,subject)
char filename[81];
char type[3];
char to[7];
char at[71];
char from[7];
char mid[14];
char subject[81];
{
execl("/ax25/mbx/exec_files/.PMAIL","/ax25/mbx/exec_files/.PMAIL",
filename,type,to,at,from,mid,subject,NULL);
}

/*---------------------------------------------------------------------------*/


from: gw3tmh at gb7abc.#51.gbr.eu (The Unix Mailbox)

