Message - Id: $GW3TMH000188
Msg Type: B$
Date: 13 Jan 97 9:07:40
From: GW3TMH
To: LINUX @ WWW
Subject: A Simple Linux Mailbox (31)

R:970113/0907z @:GB7ABC.#51.GBR.EU

/*
 * Linux version.
 *
 * File location...   /ax25/mbx/exec_files/page
 *
 */

/*----------------------------------------------------------------------------*/
/*                                                                            */
/*                                   page.c                                   */
/*                                                                            */
/*  Page called with no parameters, will give the current setting             */
/*  page called with a number from 0 to 99 will change to those settings.     */
/*                                                                            */
/*  PAGE 0   turns off all paging                                             */
/*                                                                            */
/*----------------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

void error(void);

void main(int argc, char *argv[])
{
char string1[9];
char string2[9];
char filename[81];

FILE *fp;

int ln;

if (argc > 2) error();  /* Too many parameters entered */

sprintf(filename,"/mailbox/system_files/%s.data",argv[0]);

if ((fp = fopen(filename,"r+")) != NULL)
   {

   if (argc == 1)          /* Nothing entered get current settings */
      {
      fseek(fp,117,SEEK_SET);
      fscanf(fp,"%s %s",string1,string2);
      /* Note that only the last two digits in 'Page:' are used the others */
      /* are going to be used for a different feature, so must not be read */
      /* or changed in any way */
      string2[0] = string2[4];
      string2[1] = string2[5];
      string2[2] = 0;
      ln = atoi(string2);
      }

   else
      {
      /* A new number entered, so change current settings */
      ln = atoi(argv[1]);
      if (ln > 99) error();
      fseek(fp,127,SEEK_SET);
      fprintf(fp,"%02d",ln);
      }
   printf("Paging is set at %d lines.\n",ln);
   fclose(fp);
   }
}

/*----------------------------------------------------------------------------*/

void error(void)
{
printf("Usage: PAGE number\n");
exit(0);
}

/*----------------------------------------------------------------------------*/


from: gw3tmh at gb7abc.#51.gbr.eu (The Unix Mailbox)

