Message - Id: $GW3TMH000097
Msg Type: B$
Date: 18 Dec 96 12:57:08
From: GW3TMH
To: LINUX @ WWW
Subject: A Simple Linux Mailbox (09)

R:961218/1257z @:GB7ABC.#51.GBR.EU

pmail.c part 1 of 5

/*
 * Linux version.
 *
 * File location...   /ax25/mbx/exec_files/.PMAIL
 *
 */
 
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*                                  pmail.c                                   */
/*                                                                            */
/*    This takes the mail from SP/SB and looks up the forwarding address      */
/*    then delivers it to the mailbox.                                        */
/*                                                                            */
/*    argv[1] points to the location of the source text file                  */
/*    argv[2] contains the message type                                       */
/*    argv[3] contains the message 'to'                                       */
/*    argv[4] contains the message 'at'                                       */
/*    argv[5] contains the message 'from'                                     */
/*    argv[6] contains the message 'mid'                                      */
/*    argv[7] contains the message 'subject'                                  */
/*                                                                            */
/*    If a message is addressed to req... @ this mailbox, we call a server    */
/*    called 'req...'  if this server does not exist, we call a server called */
/*    'bad_server' which could be used to inform the sender that the server   */
/*    requested is not in operation.                                          */
/*                                                                            */
/*    A personal message sent to this bbs, calls the server 'bad_message'     */
/*    if the receipient is not a registered user of this mailbox, this can    */
/*    be used to bounce the message back to the sender.                       */
/*                                                                            */
/*----------------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <signal.h>

void main(int argc, char *argv[])
{
char filename[81], type[3], to[7], at[71], from[7], mid[14], subject[81];
char test1[9], test2[256], test3[256], destination[7], month[4], hostname[31];
char from_bbs[9], mbxname[9];
int a, b, mn;
int flag = 0;
long p, sz;
time_t tnow;
struct tm *tmnow;
struct stat s;
FILE *fp, *pp;

/*
 * Ignore shutdown of terminal
 */
signal(SIGHUP, SIG_IGN);

/*
 * Make this a background task
 */
if ((a = fork()) < 0) exit(1);
else if (a > 0) exit(0);

/*
 * Enough arguements on command line ?
 */
if (argc < 6) exit(1);

/*
 * Get the current time
 */
time(&tnow);
tmnow = localtime(&tnow);

/*
 * Copy all the command line arguements into strings
 */
strcpy(type,argv[2]);
strcpy(to,argv[3]);
strcpy(at,argv[4]);
strcpy(from,argv[5]);
strcpy(mid,argv[6]);
strcpy(subject,argv[7]);

/*
 * Set the user mask
 */
umask(0111);

/*
 * Now get the callsign of this mailbox
 */
if ((fp = fopen("/etc/AX25_HOSTNAME","r")) == NULL) exit(1);
fgets(hostname,30,fp);
fclose(fp);

/*
 * Now convert all strings to upper case removing any crud 
 */
for (a = 0; hostname[a]; a++)
   {
   if (hostname[a] < 33) break;
   hostname[a] = toupper(hostname[a]);
   }
hostname[a] = 0;

for (a = 0; hostname[a]; a++)
   {
   mbxname[a] = hostname[a];
   if (mbxname[a] == '.') break;
   }
mbxname[a] = 0;

for (a = 0; mid[a]; a++)
   {
   if (mid[a] < 33) break;
   mid[a] = toupper(mid[a]);
   }
mid[a] = 0;

for (a = 0; from[a]; a++)
   {
   if (from[a] < 33) break;
   from[a] = toupper(from[a]);
   }
from[a] = 0;

for (a = 0; at[a]; a++)
   {
   if (at[a] < 33) break;
   at[a] = toupper(at[a]);
   }
at[a] = 0;

for (a = 0; to[a]; a++)
   {
   if (to[a] < 33) break;


from: gw3tmh at gb7abc.#51.gbr.eu (The Unix Mailbox)

