Message - Id: $GW3TMH000215
Msg Type: B$
Date: 22 Jan 97 8:49:21
From: GW3TMH
To: LINUX @ WWW
Subject: A Simple Linux Mailbox (40)

R:970122/0849z @:GB7ABC.#51.GBR.EU

/*
 * Linux version.
 *
 * File location...   /ax25/mbx/exec_files/sr
 *
 * File /etc/AX25_HOSTNAME  *Must* contain the full packet call of
 * this bbs,  we *cannot* use /etc/hostname, as we *need* to include
 * a "#" in the address ie     gb7abc.#51.gbr.eu   (use lower case)
 *
 */

/*****************************************************************************/
/*                                                                           */
/*                                    sr.c                                   */
/*                                                                           */
/*  Used to send a reply to a message, if no number is entered it gets the   */
/*  message number from the user data base, as the last message read.        */
/*                                                                           */
/*****************************************************************************/

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <signal.h>
#include <ctype.h>

void error(int);
void parent(void);
void child(char *, char *, char *, char *, char *, char *, char *);
void sig_ser(int);

FILE *fp1;
char filename[81];

/*----------------------------------------------------------------------------*/

void sig_ser(int i)
{
fclose(fp1);
unlink(filename);
exit(0);
}

/*----------------------------------------------------------------------------*/

void main(int argc, char *argv[])
{
int i;
long L;
char hostname[31];
char str[81];
char to[7];
char from[7];
char at[7];
char type[3];
char mid[14];
char fifo[6];
char Sent[9];
char number[9];
char tempname[15];
char ch;

if (argc > 2) error(0);

if (strlen(argv[0]) < 3) error(1);
if (strlen(argv[0]) > 6) error(1);

strcpy(from,argv[0]);

/*
 * Now see if sender is allowed to actually input mail.
 * If this is not a callsign, you cannot input mail, root & bin are not
 * callsigns, note that an unregistered user takes on the callsign of guest
 * so until a function is added to append unregistered users to the /etc/passwd
 * file, an unregistered user cannot send any mail.
 */
if (isalpha(from[0]) && isalpha(from[1]) && isdigit(from[2])) goto good_call;
if (isalpha(from[0]) && isdigit(from[1]) && isalpha(from[2])) goto good_call;
if (isdigit(from[0]) && isalpha(from[1]) && isdigit(from[2])) goto good_call;
error(1);

good_call:
 
for (i = 0; i <= 5; i++) fifo[i] = 0;

if (argc == 2)
   {
   /* A message number has been entered so get it */
   if (strlen(argv[1]) < 5) strcpy(number,argv[1]);
   else error(0);
   }

else
   {
   /* No message number entered so get it from the data base */
   sprintf(filename,"/ax25/mbx/system_files/%s.data",argv[0]);

   if ((fp1 = fopen(filename,"r")) != NULL)
      {
      fseek(fp1,104,SEEK_SET);
      fscanf(fp1,"%s %s",filename,number);
      fclose(fp1);
      }
   }

/* Now we need to peek at the mail header to see who the message is to */

if ((fp1 = fopen("/ax25/mbx/system_files/header","r")) != NULL)
   {
   L = atol(number);
   if (!L) exit(0);
   L--;
   L *= 78;
   fseek(fp1,L,SEEK_SET);
   fgets(filename,80,fp1);
   fclose(fp1);
   for (i = 0; i < 6; i++)
      {
      to[i] = filename[i +23];
      if (to[i] == ' ') break;
      }
   to[i] = 0;
   }
else error(0);

/* Ok now we have a to, and a from, so lets get a subject */
for (i = 0; i < 29; i++)
   {
   filename[i] = filename[i +47];
   }
filename[i] = 0;
/* Now see if the subject is already prefixed with 'Re:' */
if (filename[0] == 'R'
&& filename[1] == 'e'
&& filename[2] == ':'
&& filename[3] == ' ')
   {
   /* We already start with Re: */
   strcpy(str,filename);
   }

else
   {
   /* We don't start we Re: so do it now */
   sprintf(str,"Re: %s",filename);
   }

strcpy(type,"P#");

/* Create a mid */
sprintf(filename,"/ax25/mbx/system_files/%s.data",argv[0]);

if ((fp1 = fopen(filename,"r+")) != NULL)
   {
   /* If the user has an account, create a mid based on the number */
   /* of messages sent, we thus have an easy way of seeing how many */
   /* messages each user sends */
   fseek(fp1,26,SEEK_SET);
   fscanf(fp1,"%s %s",tempname,Sent);
   L = atol(Sent);
   L++;
   if (L > 999999) L = 0;
   fseek(fp1,26,SEEK_SET);
   fprintf(fp1,"Sent: %06ld\n",L);
   fclose(fp1);
   sprintf(mid,"$%s%06ld",from,L);
   }

else
   {
   /* No user account */
   printf("Unregistered user.\n");
   exit(0);
   }


if ((fp1 = fopen("/etc/AX25_HOSTNAME","r")) != NULL)
   {
   fgets(hostname,30,fp1);
   fclose(fp1);

   for (i = 0; i <= 30; i++)
      {
      if (hostname[i] == '\n') break;
      }
   hostname[i] = 0;
   }

/* now create a filename in tmp */
strcpy(tempname,"rmXXXXXX");
mktemp(tempname);

sprintf(filename,"/ax25/mbx/tmp/%s",tempname);

if ((fp1 = fopen(filename,"w")) != NULL)
   {
   signal(SIGHUP,sig_ser);
   strcpy(at,"------");
   printf("Sending reply to %s\n%s\n",to,str);

   fprintf(fp1,"\n");

   for (;;)
      {
      ch = getchar();
      fifo[5] = ch;

      if (fifo[0] != 0)
         fputc(fifo[0],fp1);

      for (i = 0; i <= 4; i++)
         fifo[i] = fifo[i + 1];

      fifo[5] = 0;

      if (!strcmp(fifo,"\n/ex\n"))
         {
         break;
         }

      if (!strcmp(fifo,"\n/EX\n"))
         {
         break;
         }

      if (fifo[3] == 26)
         {
         fputc(fifo[0],fp1);
         fputc(fifo[1],fp1);
         fputc(fifo[2],fp1);
         break;
         }
      }
   fputc('\n',fp1);

   /* Now see if we have a signature to add */

   fprintf(fp1,"\nfrom: %s at %s (The Unix Mailbox)\n",
   from,hostname);

   fclose(fp1);
   signal(SIGHUP,SIG_DFL);

   /* Now pass mail to pmail */

   if (fork()) parent();
   else child(filename,type,to,at,from,mid,str);
   exit(0);
   }
}

/*----------------------------------------------------------------------------*/

/* Process error messages */

void error(e)
int e;
{
if (e) printf("Sorry you are not allowed to use the SR command.\n"); 
else printf("Usage: SR\n");
exit(0);
}

/*----------------------------------------------------------------------------*/

void parent(void)
{
exit(0);
}

/*---------------------------------------------------------------------------*/

void child(filename,type,to,at,from,mid,subject)
char filename[81];
char type[3];
char to[7];
char at[7];
char from[7];
char mid[14];
char subject[81];
{
execl("/ax25/mbx/exec_files/.PMAIL","/ax25/mbx/exec_files/.PMAIL",
filename,type,to,at,from,mid,subject,NULL);
}

/*---------------------------------------------------------------------------*/


from: gw3tmh at gb7abc.#51.gbr.eu (The Unix Mailbox)

